atom/movable/Bump(atom/A)
	world << "[src]{[x],[y]}.Bump([A]{[A.x],[A.y]})"

atom/movable/Click()
	usr << "[src].density = [density]"
	usr << "Distance to [src] is [bigatom_get_dist(usr,src)]"
	usr << "Icon: [icon]   State: [icon_state]"
	usr << "overlays: [overlays.len]"
	usr << "x: [x]   y: [y]   layer: [layer]"

mob
	icon = 'bigatomdemo.dmi'
	icon_state = "smile"
	density = 1
	bigatom_mode = BIGATOM_NOOVERLAYS
	bigatom_layer_shift_y = 2

	bigatom_Resized()
		top_density(density)

	Login()
		..()
		// set the name of all the parts created before the client logged in
		bigatom_Var("name", name)

	Stat()
		suffix = "State: [icon_state]\nRelative Pos: [bigatom_x],[bigatom_y]\nRelative Pos: [bigatom_X()],[bigatom_Y()]\nLoc: [x],[y]"
		stat(src)
		var/flags = "Flags: "
		if(bigatom_mode & BIGATOM_ON) flags += "BIGATOM_ON "
		if(bigatom_mode & BIGATOM_NOOVERLAYS) flags += "BIGATOM_NOOVERLAYS "
		if(bigatom_mode & BIGATOM_MAYMOVENULL) flags += "BIGATOM_MAYMOVENULL "
		if(bigatom_mode & BIGATOM_PRESERVEPARTS) flags += "BIGATOM_PRESERVEPARTS "
		if(bigatom_mode & BIGATOM_REGENERATEPARTS) flags += "BIGATOM_REGENERATEPARTS "
		if(bigatom_mode & BIGATOM_PARTS_NONE) flags += "BIGATOM_PARTS_NONE "

		if(bigatom_mode & BIGATOM_PARTS_CORNERS) flags += "BIGATOM_PARTS_CORNERS "
		stat(flags)

		if(bigatom_parts)
			stat("[bigatom_parts.len] parts")
			for(var/mob/M in bigatom_parts)
				M.suffix = "State: [M.icon_state]\nRelative Pos: [M.bigatom_x],[M.bigatom_y]\nRelative Pos: [M.bigatom_X()],[M.bigatom_Y()]\nLoc: [M.x],[M.y]"
				stat(M)

	verb
		say(T as text)
			world << "<B>[src]:</B> [html_encode(copytext(T,1,512))]"
			if(bigatom_StatePrefix() == "smile")
				bigatom_flick("talk", src)

		state()
			var/list/options = list("\"\"") + icon_states(icon)
			for(var/S in options)
				if(findtext(S, ",")) options -= S
			var/new_state = input("","New Icon state",icon_state) as null|anything in options
			if(new_state)
				if(new_state == "\"\"") new_state = ""
				bigatom_Var("icon_state", new_state)

		top_density(n as num)
			if(bigatom_x == bigatom_bottom)
				src << "You are only a single tile tall."
				return
			density = n
			for(var/mob/M in bigatom_parts)
				if(M.bigatom_y > bigatom_bottom)
					M.density = density
			if(density)
				src << "Your top is dense, representing a mob flat on the map."
			else
				src << "Your top is not dense, representing a tall mob with the top floating \
					over the map."

obj/ball
	icon = 'bigatomdemo.dmi'
	density = 1
	bigatom_mode = BIGATOM_ON	// use overlay mode if applicable


	New()
		..()
		spawn(2)
			if(bigatom_src == src)
				while(src)
					sleep(2)
					if(!step(src, dir))
						dir = turn(dir, 180)

	pillar
		icon_state = "pillar"
		dir = WEST
		bigatom_layer_shift_y = 2
		New()
			..()
			if(!bigatom_building)
				density = 0
				for(var/obj/M in bigatom_parts)
					if(M.bigatom_y > bigatom_bottom)
						M.density = 0

turf
	icon = 'bigatomdemoturf.dmi'
	wall
		icon = 'bigatomdemowall.dmi'
		density = 1
		layer = MOB_LAYER + 1